#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1900three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three19004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three19004xi = {
                1:'0x1844y-456z',
                2:'0x37y-1899z',
                3:'1021x1356y-851z',
                4:'1025x1579y-251z',
                5:'1027x1466y-635z',
                6:'105x510y-1827z',
                7:'1068x1190y-1024z',
                8:'108x199y-1886z',
                9:'1096x1308y-834z',
                10:'1106x1415y-617z',
                11:'1108x1525y-232z',
                12:'110x1590y-1032z',
                13:'1136x1140y-1008z',
                14:'1169x1254y-817z',
                15:'117x83y-1894z',
                16:'1182x1360y-599z',
                17:'1188x1467y-213z',
                18:'1202x1086y-992z',
                19:'1238x1197y-800z',
                20:'1256x1301y-581z',
                21:'1264x1404y-194z',
                22:'1265x1027y-976z',
                23:'129x209y-1884z',
                24:'12x93y-1897z',
                25:'1305x1136y-783z',
                26:'1325x965y-959z',
                27:'1327x1237y-563z',
                28:'1337x1337y-176z',
                29:'1369x1071y-765z',
                30:'136x522y-1821z',
                31:'1394x1169y-545z',
                32:'1407x1266y-157z',
                33:'1430x1002y-748z',
                34:'1457x1098y-526z',
                35:'1472x1192y-138z',
                36:'149x1711y-811z',
                37:'150x217y-1881z',
                38:'1517x1023y-508z',
                39:'1534x1114y-119z',
                40:'158x1534y-1272z',
                41:'169x531y-1816z',
                42:'173x224y-1878z',
                43:'18x24y-1899z',
                44:'193x1842y-419z',
                45:'194x1593y-1016z',
                46:'196x229y-1875z',
                47:'1x56y-1899z',
                48:'203x538y-1810z',
                49:'20x111y-1896z',
                50:'21x465y-1841z',
                51:'221x232y-1872z',
                52:'228x1460y-1194z',
                53:'238x544y-1804z',
                54:'240x1709y-793z',
                55:'247x233y-1869z',
                56:'26x1584y-1048z',
                57:'273x232y-1865z',
                58:'274x546y-1798z',
                59:'279x1590y-1000z',
                60:'290x1834y-401z',
                61:'299x228y-1862z',
                62:'307x1457y-1179z',
                63:'311x547y-1792z',
                64:'31x128y-1895z',
                65:'31x38y-1899z',
                66:'326x223y-1858z',
                67:'330x1702y-776z',
                68:'349x545y-1786z',
                69:'364x1583y-984z',
                70:'386x1450y-1164z',
                71:'386x1820y-382z',
                72:'388x540y-1779z',
                73:'421x1690y-759z',
                74:'427x533y-1772z',
                75:'43x145y-1893z',
                76:'449x1571y-968z',
                77:'465x1439y-1149z',
                78:'466x523y-1765z',
                79:'46x50y-1898z',
                80:'47x482y-1837z',
                81:'482x1801y-364z',
                82:'505x511y-1758z',
                83:'511x1672y-741z',
                84:'534x1554y-951z',
                85:'544x1424y-1134z',
                86:'544x495y-1751z',
                87:'577x1776y-345z',
                88:'57x160y-1892z',
                89:'583x477y-1744z',
                90:'59x1708y-828z',
                91:'600x1650y-724z',
                92:'618x1533y-935z',
                93:'621x456y-1736z',
                94:'622x1403y-1118z',
                95:'62x61y-1897z',
                96:'658x433y-1728z',
                97:'670x1747y-326z',
                98:'689x1623y-706z',
                99:'6x75y-1898z',
                100:'6x9y-1899z',
                101:'700x1379y-1103z',
                102:'702x1507y-918z',
                103:'72x174y-1890z',
                104:'75x497y-1832z',
                105:'762x1712y-307z',
                106:'776x1350y-1087z',
                107:'776x1591y-688z',
                108:'784x1476y-902z',
                109:'79x70y-1897z',
                110:'852x1316y-1072z',
                111:'852x1673y-289z',
                112:'861x1554y-671z',
                113:'865x1441y-885z',
                114:'90x187y-1888z',
                115:'926x1279y-1056z',
                116:'940x1628y-270z',
                117:'944x1401y-868z',
                118:'945x1513y-653z',
                119:'96x1846y-438z',
                120:'98x77y-1895z',
                121:'998x1237y-1040z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1900three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE19000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE19000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE19000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE19000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE19000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE19000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE19000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE19000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three19004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three19004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE19000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE19000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE19000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                